routes/web.php
<?php

use App\Http\Controllers\MasterBarangController;
use App\Http\Controllers\PembelianController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

Route::resource('/barang', MasterBarangController::class)->middleware('auth');

Route::get('/pembelian', [PembelianController::class, 'indexPembelian'])->name('pembelian.index');
Route::get('/pembelian/create', [PembelianController::class, 'createPembelianBarang'])->name('pembelian.create');
Route::post('/pembelian', [PembelianController::class, 'storePembelianBarang'])->name('pembelian.store');

app/Models/master_barang.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class master_barang extends Model
{
    use HasFactory;

    protected $guard = [];

    protected $table = 'master_barangs';

    protected $fillable = [
        'nama_barang',
        'harga_satuan'
    ];
}

app/Http/Controllers/MasterBarangController.php
<?php

namespace App\Http\Controllers;

use App\Models\master_barang;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;
use RealRashid\SweetAlert\Facades\Alert;

class MasterBarangController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $title = "List Barang";

        $master_barang = master_barang::paginate(5)->withQueryString();

        return view('masterBarang.index', compact(['title', 'master_barang']));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $title = "Tambahkan Barang";
        return view('masterBarang.create', compact(['title']));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {

        $rule = [
            'namaBarang'    => 'required|min:4',
            'hargaSatuan'   => 'required|numeric|min:0',
            'jumlah'        => 'required|numeric|min:0',
            'hargaTotal'    => 'required|numeric|min:0',
        ];

        $validator = Validator::make($request->all(), $rule);

        if ($validator->fails()) {
            return redirect()->route('barang.create')
                ->withErrors($validator)
                ->withInput();
        }

        $data = [
            'nama_barang' => $request->namaBarang,
            'harga_satuan' => $request->hargaSatuan
        ];

        master_barang::create($data);
        toast('Data barang berhasil ditambahkan', 'success');
        return redirect()->route('barang.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $barang = master_barang::findOrFail($id);
        $title = "ubah barang";

        return view('masterBarang.edit', compact(['barang', 'title']));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $barang = master_barang::find($id);

        $rule = [
            'namaBarang'    => 'required|min:4',
            'hargaSatuan'   => 'required|numeric|min:0'
        ];

        $validator = Validator::make($request->all(), $rule);

        if ($validator->fails()) {
            return redirect()->route('barang.edit', $id)
                ->withErrors($validator)
                ->withInput();
        }

        $data = [
            'nama_barang' => $request->namaBarang,
            'harga_satuan' => $request->hargaSatuan
        ];

        master_barang::where('id', $id)->update($data);
        toast('Data ' . $barang->nama_barang . ' berhasil diperbaharui', 'info');
        return redirect()->route('barang.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $barang = master_barang::find($id);

        toast('Data ' . $barang->nama_barang . ' berhasil dihapuskan', 'error');
        master_barang::where('id', $id)->delete();
        return redirect()->route('barang.index');
    }
}

resources/views/masterBarang/create.blade.php
@extends('layouts.template')

@section('content')
<div class="container-fluid px-4">
    <h1 class="mt-4 text-uppercase">{{$title}}</h1>
    <ol class="breadcrumb mb-3">
        <li class="breadcrumb-item active text-uppercase">{{$title}}</li>
    </ol>
    <hr>
    <div class="row mb-2">
        <div class="col-12">
            <a href="{{ route('barang.index') }}" class="btn btn-sm btn-outline-secondary">
                kembali
            </a>
        </div>
    </div>

    <div class="row">
        <div class="col-12">
            <div class="card text-bg-light">
                <div class="card-header text-center text-uppercase">
                    <h5>Formulir Penambahan barang</h5>
                </div>
                <div class="card-body">
                    <form action="{{ route('barang.store') }}" method="POST">
                        @csrf
                        <div class="mb-3">
                            <label for="namaBarang" class="form-label">Nama Barang</label>
                            <input type="text" class="form-control" id="namaBarang" aria-describedby="namaBarang" name="namaBarang">
                            @error('namaBarang')
                            <div id="namaBarang" class="form-text text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="mb-3">
                            <label for="hargaSatuan" class="form-label">Harga Satuan</label>
                            <input type="text" class="form-control" id="hargaSatuan" name="hargaSatuan">
                            @error('hargaSatuan')
                            <div id="hargaSatuan" class="form-text text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="mb-3">
                            <label for="jumlah" class="form-label">Jumlah</label>
                            <input type="text" class="form-control" id="jumlah" name="jumlah">
                            @error('jumlah')
                            <div id="jumlah" class="form-text text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="mb-3">
                            <label for="hargaTotal" class="form-label">Harga Total</label>
                            <input type="text" class="form-control" id="hargaTotal" name="hargaTotal">
                            @error('hargaTotal')
                            <div id="hargaTotal" class="form-text text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <button type="submit" class="btn btn-sm btn-outline-primary">tambahkan</button>
                        <a href="{{ route('barang.index') }}" class="btn btn-sm btn-outline-secondary">
                            tutup
                        </a>
                    </form>
                </div>
            </div>
        </div>
    </div>

</div>
@endsection

resources/views/masterBarang/edit.blade.php
@extends('layouts.template')

@section('content')
<div class="container-fluid px-4">
    <h1 class="mt-4 text-uppercase">{{$title}}</h1>
    <ol class="breadcrumb mb-3">
        <li class="breadcrumb-item active text-uppercase">{{$title}}</li>
    </ol>
    <hr>
    <div class="row mb-2">
        <div class="col-12">
            <a href="{{ route('barang.index') }}" class="btn btn-sm btn-outline-secondary">
                kembali
            </a>
        </div>
    </div>

    <div class="row">
        <div class="col-12">
            <div class="card text-bg-light">
                <div class="card-header text-center text-uppercase">
                    <h5>Formulir Penambahan barang</h5>
                </div>
                <div class="card-body">
                    <form action="{{ route('barang.update', $barang->id) }}" method="POST">
                        @csrf
                        @method('PUT')
                        <div class="mb-3">
                            <label for="namaBarang" class="form-label">Nama Barang</label>
                            <input type="text" class="form-control" id="namaBarang" aria-describedby="namaBarang" name="namaBarang" value="{{ $barang->nama_barang }}">
                            @error('namaBarang')
                            <div id="namaBarang" class="form-text text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="mb-3">
                            <label for="hargaSatuan" class="form-label">Harga Satuan</label>
                            <input type="text" class="form-control" id="hargaSatuan" name="hargaSatuan" value="{{ $barang->harga_satuan }}">
                            @error('hargaSatuan')
                            <div id="hargaSatuan" class="form-text text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <button type="submit" class="btn btn-sm btn-outline-primary">tambahkan</button>
                        <a href="{{ route('barang.index') }}" class="btn btn-sm btn-outline-secondary">
                            tutup
                        </a>
                    </form>
                </div>
            </div>
        </div>
    </div>

</div>
@endsection

resources/views/masterBarang/index.blade.php
@extends('layouts.template')

@section('content')
<div class="container-fluid px-4">
    <h1 class="mt-4 text-uppercase">{{$title}}</h1>
    <ol class="breadcrumb mb-3">
        <li class="breadcrumb-item active text-uppercase">{{$title}}</li>
    </ol>
    <hr>
    <div class="row mb-2">
        <div class="col-12">
            <a href="{{ route('barang.create') }}" class="btn btn-sm btn-outline-info">
                formulir barang
            </a>
        </div>
    </div>
    <div class="row">
        <div class="col-12">
            <table class="table table-bordered table-condensed table-hover">
                <thead>
                    <tr>
                        <th>#</th>
                        <th>Nama Barang</th>
                        <th>Harga Satuan</th>
                        <th>Created</th>
                        <th>Updated</th>
                        <th>Action</th>
                    </tr>
                </thead>
                <tbody>
                    @foreach ($master_barang as $key => $barang)
                    <tr>
                        <td>{{ $key + $master_barang->firstItem() }}</td>
                        <td>{{ $barang->nama_barang }}</td>
                        <td>{{ $barang->harga_satuan }}</td>
                        <td>{{ $barang->created_at }}</td>
                        <td>{{ $barang->updated_at }}</td>
                        <td>
                            <a href="{{ route('pembelian.create', $barang->id) }}" class="btn btn-sm btn-outline-secondary">form pembelian</a>
                            <a href="{{ route('barang.edit', $barang->id) }}" class="btn btn-outline-warning btn-sm">
                                ubah
                            </a>
                            <button href="{{ route('barang.destroy', $barang->id) }}" class="btn btn-outline-danger btn-sm" id="delete">
                                hapus
                            </button>
                        </td>
                    </tr>
                    @endforeach
                </tbody>
            </table>
            <span class="float-end">{{ $master_barang->links() }}</span>
        </div>
    </div>
</div>

<form action="" method="post" id="deleteForm">
    @csrf
    @method("DELETE")
    <input type="submit" value="Hapus" style="display: none">
</form>


<script src="https://code.jquery.com/jquery-3.6.1.js" integrity="sha256-3zlB5s2uwoUzrXK3BT7AX3FyvojsraNFxCc2vC/7pNI=" crossorigin="anonymous"></script>
<script src="//cdn.jsdelivr.net/npm/sweetalert2@9/dist/sweetalert2.min.js"></script>

<script src="https://cdn.jsdelivr.net/npm/sweetalert2@8"></script>

<script>
    $('button#delete').on('click', function(e) {
        e.preventDefault();
        var href = $(this).attr('href');

        const swalWithBootstrapButtons = Swal.mixin({
            customClass: {
                confirmButton: 'btn btn-sm btn-success',
                cancelButton: 'btn btn-sm btn-danger'
            },
            buttonsStyling: false
        });

        Swal.fire({
            title: 'Apakah kamu yakin?',
            text: "Anda tidak akan dapat mengembalikannya!",
            icon: 'warning',
            showCancelButton: true,
            confirmButtonText: 'Ya, Hapus ini!',
            cancelButtonText: 'Tidak, Batalkan!',
        }).then((result) => {
            if (result.value) {
                document.getElementById('deleteForm').action = href;
                document.getElementById('deleteForm').submit();

                swalWithBootstrapButtons.fire(
                    'Terhapus!',
                    'Data berhasil dihapus dari sistem.',
                    'success'
                )
            } else if (
                result.dismiss === Swal.DismissReason.cancel
            ) {
                swalWithBootstrapButtons.fire(
                    'Dibatalkan',
                    'Data berhasil diamakan :)',
                    'error'
                )
            }
        });
    });
</script>
@endsection